
Ruby - Bug #20168

Process won't exit when Ractor.select waiting a Ractor

01/09/2024 09:29 AM - shia (Sangyong Sim)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 3.3.0 Backport: 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2:

UNKNOWN, 3.3: UNKNOWN

Description

Reproduction code

trap(:INT) do

  puts "SIGINT"

  exit

end

trap(:TERM) do

  puts "SIGTERM"

  exit

end

r = Ractor.new do

  loop do

    sleep 1

  end

end

Ractor.select(r) # stucked.

# SIGINT/SIGTERM sent to Ruby process(confirmed by trap),

# but process won't exit.

 

Expected behavior

Process killed successfully with exit code 0.

Affected Ruby version

3.3.0

3.2.x works as expected.

Associated revisions

Revision 6747fbe77dcac26a457bb1386f55f3c27321040a - 05/05/2024 03:14 PM - luke-gru (Luke Gruber)

Fix interrupts during Ractor.select

Fixes [Bug #20168]

Revision 6747fbe77dcac26a457bb1386f55f3c27321040a - 05/05/2024 03:14 PM - luke-gru (Luke Gruber)

Fix interrupts during Ractor.select

Fixes [Bug #20168]

Revision 6747fbe7 - 05/05/2024 03:14 PM - luke-gru (Luke Gruber)

Fix interrupts during Ractor.select

Fixes [Bug #20168]

History
#1 - 01/11/2024 05:14 PM - luke-gru (Luke Gruber)

Patch here: https://github.com/ruby/ruby/pull/9492

#2 - 03/26/2024 03:02 PM - over.rye@gmail.com (Masato Ohba)

I think I have encountered the same issue. I was able to reproduce the problem using a simpler code that results in a process hang when a Ractor,

which internally raises an exception, is passed to Ractor.select.

Here is the minimal code snippet that demonstrates the issue:

ruby -e "r = Ractor.new{1/0}; Ractor.select(*[r])"

 Notably, when I built Ruby using the branch from https://github.com/ruby/ruby/pull/9492, the issue did not occur. It appears that the changes in this

branch might contain a fix or alter the behavior to prevent the hang.

#3 - 05/05/2024 05:24 PM - luke-gru (Luke Gruber)

- Status changed from Open to Closed

Applied in changeset git|6747fbe77dcac26a457bb1386f55f3c27321040a.

Fix interrupts during Ractor.select

Fixes [Bug #20168]
